#include <qimage.h>
#include <qcolor.h>

require "qt2"
include Qt2

def blendComponent( v, av,  s,  as )

    return as*s + av*v - (av*as*s) / 255
end
    
def blendShade( v,  s )

    #//shadow image is already reduced and blurred
     as = qAlpha(s)
     av = qAlpha(v)
    if ( as == 0 || av == 255 )
	return v
    end
     a = as + av - (as*av) / 255
    
     r = blendComponent( qRed(v),av, qRed(s), as) / a
     g = blendComponent( qGreen(v),av, qGreen(s), as) / a
     b = blendComponent( qBlue(v),av, qBlue(s), as) / a

    return qRgba(r,g,b,a)
end

 

#int main( int*, char**)

    image = QImage.new()
    image.load( "out.png" )
    image.convertDepth( 32 )
    shade = QImage.new()
    shade.load( "outshade.png" )
    shade.convertDepth( 32 )
    dx = 10
    dy = 5
	
    w = image.width()
    h = image.height()
	
    img = QImage.new()
    img.create( w+dx, h+dy, 32 )
    img.setAlphaBuffer( TRUE )

    for y in 0..( h + dy - 1) #( int y = 0 y < h+dy y++ )
	for x in 0..( w + dx - 1) #( int x = 0 x < w+dx x++ )
	    sh =  (x<dx || y<dy) ? 0 : shade.pixel( x-dx, y-dy )
	    pixel = ((x<w) & (y<h)) ? image.pixel( x, y ) : 0
	    img.setPixel( x, y, blendShade( pixel, sh ) ) 
	end
    end
    img.save("blend.png", "PNG" )



