#include <qimage.h>
#include <qcolor.h>
require "qt2"
include Qt2

def blendComponent( v, av, s, as )

    #//shadow gets a color inversely proportional to the
    #//alpha value
    s = (s*(255-as))/255
    #//then do standard blending
    return (as * s + av * v - (( av * as * s) / 255)  )
end
    
def blendShade( v, s )

    #//pick a number: shadow is 1/3 of object
    as = qAlpha(s)/3
    av = qAlpha(v)
    if ( as == 0 || av == 255 )
	return v
    end
    a = as + av - (as * av) / 255

    
    r = blendComponent( qRed(v),av, qRed(s), as)/a
    g = blendComponent( qGreen(v),av, qGreen(s), as)/a
    b = blendComponent( qBlue(v),av, qBlue(s), as)/a

    return qRgba(r,g,b,a)
end


    img = QImage.new()
    img.load( "in.png" )
    img.setAlphaBuffer( TRUE )
    img = img.convertDepth( 32 )
    w = img.width()
    h = img.height()
#if 0
    for y in 0..(h - 1) #( y = 0 y < h y ++ )
	line = img.scanLine( y )
	for x in 0..( w - 1) #( int x = 0 x < w x++ )
	    pixel = line[x]
	    r = qRed(pixel)
	    g = qGreen(pixel)
	    b = qBlue(pixel)
	    min = QMIN( r, QMIN( g, b ) )
	    max = QMAX( r, QMAX( g, b ) )
	    r -= min
	    g -= min
	    b -= min
	    if ( max !=min ) 
		r = (r*255)/(max-min)
		g = (g*255)/(max-min)
		b = (b*255)/(max-min)
	    end
	    a = 255-min
	    a -=  (max - min) / 3 #//hack more transparency for colors.
	    #line[x] = qRgba( r, g, b, a )  #// How can I implement it to Ruby/Qt ?
	end
    end
#endif

#main
    img = img.smoothScale( w/2, h/2 )

    print( "saving out.png\n")
    img.save( "out.png", "PNG" )
    
    w = img.width()
    h = img.height()
    
    img2 = QImage.new()
    img2.create( w, h, 32 )
    img2.setAlphaBuffer( TRUE )

    for y in 0..(h - 1) #( y = 0 y < h y++ )
	for x in 0..(w - 1) #( int x = 0 x < w x++ )
	    shader = img.pixel( x, y )

	    as = qAlpha(shader)/3

	    r = (qRed(shader)*(255-as))/255
	    g = (qGreen(shader)*(255-as))/255
	    b = (qBlue(shader)*(255-as))/255

	    img2.setPixel( x, y, qRgba(r,g,b,as) ) 
	end
    end

    img2.save( "outshade.png", "PNG" )


